'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

// import { Mongo } from 'meteor/mongo';
// import { check, Match } from 'meteor/check';

var Method = exports.Method = new Mongo.Collection('meteor_abac_method');

var addMethod = exports.addMethod = function addMethod(method) {
  check(method, {
    name: String,
    desc: Match.Optional(String),
    isPublished: Match.Optional(Boolean)
  });

  var now = new Date();

  Method.upsert({
    name: method.name
  }, {
    $set: _extends({
      isPublished: false }, method, {
      createdAt: now,
      modifiedAt: now
    })
  });
};

var removeMethod = exports.removeMethod = function removeMethod(name) {
  check(name, String);

  Method.remove({
    name: name
  });
};

var doesMethodExist = exports.doesMethodExist = function doesMethodExist(name) {
  check(name, String);

  return !!Method.findOne({
    name: name
  });
};

var isMethodPublished = exports.isMethodPublished = function isMethodPublished(name) {
  check(name, String);

  var m = Method.findOne({
    name: name
  });

  return m && m.isPublished;
};