'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

// import { Mongo } from 'meteor/mongo';
// import { check, Match } from 'meteor/check';

var Publication = exports.Publication = new Mongo.Collection('meteor_abac_publication');

var addPublication = exports.addPublication = function addPublication(pub) {
  check(pub, {
    name: String,
    desc: Match.Optional(String),
    isPublished: Match.Optional(Boolean)
  });

  var now = new Date();

  Publication.upsert({
    name: pub.name
  }, {
    $set: _extends({
      isPublished: false }, pub, {
      createdAt: now,
      modifiedAt: now
    })
  });
};

var removePublication = exports.removePublication = function removePublication(name) {
  check(name, String);

  Publication.remove({
    name: name
  });
};

var doesPublicationExist = exports.doesPublicationExist = function doesPublicationExist(name) {
  check(name, String);

  return !!Publication.findOne({
    name: name
  });
};

var isPublicationPublished = exports.isPublicationPublished = function isPublicationPublished(name) {
  check(name, String);

  var p = Publication.findOne({
    name: name
  });

  return p && p.isPublished;
};