'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.id = undefined;

var _crypto = require('crypto');

var _crypto2 = _interopRequireDefault(_crypto);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UNMISTAKABLE_CHARS = '23456789ABCDEFGHJKLMNPQRSTWXYZabcdefghijkmnopqrstuvwxyz';

var hexString = function hexString(digits) {
  var numBytes = Math.ceil(digits / 2);

  var bytes = void 0;

  try {
    bytes = _crypto2.default.randomBytes(numBytes);
  } catch (e) {
    bytes = _crypto2.default.pseudoRandomBytes(numBytes);
  }

  var result = bytes.toString('hex');

  return result.substring(0, digits);
};

var fraction = function fraction() {
  return parseInt(hexString(8), 16) * 2.3283064365386963e-10; // 2^-32
};

var choice = function choice(arrayOrString) {
  var index = Math.floor(fraction() * arrayOrString.length);

  if (typeof arrayOrString === 'string') {
    return arrayOrString.substr(index, 1);
  }

  return arrayOrString[index];
};

var randomString = function randomString(charsCount, alphabet) {
  var digits = [];

  for (var i = 0; i < charsCount; i++) {
    digits[i] = choice(alphabet);
  }

  return digits.join('');
};

var id = exports.id = function id() {
  var charsCount = arguments.length <= 0 || arguments[0] === undefined ? 17 : arguments[0];

  return randomString(charsCount, UNMISTAKABLE_CHARS);
};